//+------------------------------------------------------------------+
//|                                         VoltyChannel_Stop_v2.mq4 |
//|                                Copyright  2007, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1




extern int    MaPrice         = 0;  //Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
extern int    MaLength        = 1; //MA's Period 
extern int    MaMode          = 0;
       int    ATR_Length      = 10; //ATR's Period
extern double Kv              = 4;  //Volatility's Factor or Multiplier
       double MoneyRisk       = 1;  //Offset Factor 
       int    VisualMode      = 1;  //0-lines,1-dots 

       bool   alertsOn        = true;
       bool   alertsOnCurrent = false;
       bool   alertsMessage   = true;
       bool   alertsSound     = false;
       bool   alertsEmail     = false;
       string soundfile       = "alert2.wav"; 


double UpBuffer[];
double DnBuffer[];
double UpSignal[];
double DnSignal[];
double smin[];
double smax[];
double trend[];


  int init()
  {
   
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,UpSignal);
   SetIndexBuffer(3,DnSignal);
   SetIndexBuffer(4,smin);
   SetIndexBuffer(5,smax);
   SetIndexBuffer(6,trend);
   
   if(VisualMode==0)
   {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   }
   else
   {
   SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);
   SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);
   }
   SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,108);
   SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,108);
   
   IndicatorShortName("VoltyChannel_Stop("+MaLength+","+ATR_Length+","+DoubleToStr(Kv,3)+")");
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DnTrend");
   SetIndexLabel(2,"UpSignal");
   SetIndexLabel(3,"DnSignal");

   return(0);
  }

//+------------------------------------------------------------------+
//| VoltyChannel_Stop_2                                              |
//+------------------------------------------------------------------+
int start()
  {
   
   int counted_bars=IndicatorCounted();
   int shift,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
     
	   for(shift=limit;shift>=0;shift--) 
      {	
      if(MaPrice==2 || MaPrice==3)
      {
      double bprice = iMA(NULL,0,MaLength,0,MaMode,PRICE_HIGH,shift);
      double sprice = iMA(NULL,0,MaLength,0,MaMode,PRICE_LOW, shift);
      }
      else
      {
      bprice = iMA(NULL,0,MaLength,0,MaMode,MaPrice,shift);
      sprice = iMA(NULL,0,MaLength,0,MaMode,MaPrice,shift);
      }
       
      smin[shift] = sprice - Kv * iATR(NULL,0,ATR_Length,shift); 
	   smax[shift] = bprice + Kv * iATR(NULL,0,ATR_Length,shift);
	
      trend[shift]=trend[shift+1];
      if (bprice > smax[shift+1]) trend[shift] =  1;
      if (sprice < smin[shift+1]) trend[shift] = -1;
	
      if (trend[shift] > 0) 
	   {
	   if(smin[shift] < smin[shift+1]) smin[shift] = smin[shift+1];
	      UpBuffer[shift] = smin[shift] - (MoneyRisk - 1) * iATR(NULL,0,ATR_Length,shift);
	   
	   if(UpBuffer[shift] < UpBuffer[shift+1] && UpBuffer[shift+1]!=EMPTY_VALUE) 
	      UpBuffer[shift] = UpBuffer[shift+1];
	   
	   if(trend[shift+1] != trend[shift]) UpSignal[shift] = UpBuffer[shift];
	   
	   else UpSignal[shift] = EMPTY_VALUE;
	        DnBuffer[shift] = EMPTY_VALUE;
	        DnSignal[shift] = EMPTY_VALUE;
	   }
	   
	   else
	   
	   if (trend[shift] < 0) 
	   {
	   if( smax[shift]>smax[shift+1]) smax[shift] = smax[shift+1];
	   DnBuffer[shift] = smax[shift] + (MoneyRisk - 1) * iATR(NULL,0,ATR_Length,shift);
	   
	   if(DnBuffer[shift] > DnBuffer[shift+1])
	      DnBuffer[shift] = DnBuffer[shift+1];
	    
	   if(trend[shift+1] != trend[shift]) 
	      DnSignal[shift] = DnBuffer[shift];
	   
	   else DnSignal[shift] = EMPTY_VALUE;
	        UpBuffer[shift] = EMPTY_VALUE;
	        UpSignal[shift] = EMPTY_VALUE;
	   }
      }
      if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("up");
         else  doAlert("down");       
   }

   //
   //
   //
   //
          
   return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Volty channel trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Volty channel "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}




